reg  [31:0]     rdata    ; 
wire  [31:0]               MODE_SELECT                     ; 
reg                       MODE_SELECT_en                  ; 
wire  [31:0]               SOFTWARE_CTRL                   ; 
reg                       SOFTWARE_CTRL_in                ; 
reg                       SOFTWARE_CTRL_out               ; 
wire  [31:0]               DATA_FRAME                      ; 
 

always  @(posedge clk or negedge rst_n)begin 
    if(rst_n==1'b0)begin 
        MODE_SELECT_en <= 0 ; 
    end 
    else if(reg_wr && flag_get_addr==16'h0000 )begin 
        MODE_SELECT_en <= flag_get_data[0]; 
    end 
end 

always  @(posedge clk or negedge rst_n)begin 
    if(rst_n==1'b0)begin 
        SOFTWARE_CTRL_in <= 0 ; 
    end 
    else if(reg_wr && flag_get_addr==16'h0001 )begin 
        SOFTWARE_CTRL_in <= flag_get_data[1]; 
    end 
    else begin 
        SOFTWARE_CTRL_in <= 0 ; 
    end 
end 

always  @(posedge clk or negedge rst_n)begin 
    if(rst_n==1'b0)begin 
        SOFTWARE_CTRL_out <= 0 ; 
    end 
    else if(reg_wr && flag_get_addr==16'h0001 )begin 
        SOFTWARE_CTRL_out <= flag_get_data[0]; 
    end 
    else begin 
        SOFTWARE_CTRL_out <= 0 ; 
    end 
end 

assign     MODE_SELECT =  { 31'b0, MODE_SELECT_en} ;
assign     SOFTWARE_CTRL =  { 30'b0, SOFTWARE_CTRL_in, SOFTWARE_CTRL_out} ;
assign     DATA_FRAME =  { DATA_FRAME_data} ;
always  @(*)begin 
    case(flag_get_addr) 
        16'h0000: rdata = MODE_SELECT                      ; 
        16'h0001: rdata = SOFTWARE_CTRL                    ; 
        16'h0002: rdata = DATA_FRAME                       ; 
        default  : rdata = 0; 
    endcase 
end 
